//Linear X.X Errechnet einfache Funktionen aus gegebenen Punkten
//Untersttzte Funktionen sind Lineare Funktionen(auch Ausgleichsgeraden) und Parabeln.
//Zur Ausgabe stehen drei verschiedene Wertetabellen bereit.

//Copyright (C) 2002 Fabian Keil

//Diese Programm steht unter der GNU General Public License(GPL) der Free Software Foundation.
//Benutzung auf eigenes Risiko!

#include<stdio.h>
#include<conio.h>
#include <stdlib.h>
#include<ctype.h>

#define _name "Linear 0.85 beta"

/*
 nderungen
 0.85 gibaus() rundet nun und schneidet nicht mehr nur ab.
*/
void design(void);
double inteingabe(int, int, int);
double berechnungn(double, double, double);
double berechnungm(double, double, double, double);
void gehwegtabelle(void);
void maldaskreuz(char);
int checkwerte(double, double, int);
void berechnung(double p1x,double p1y, double p2x, double p2y, double &steigungm, double &verschiebungn);
double scanfstinkt(int,int,int,int);
void funktionsausgabe(double, double);
double quadratvon(double);
void leerefeldoben(void);

void information(void)
{
 int x=27;
 int y=12;
 maldaskreuz('I');
 gehwegtabelle();
 gotoxy(x,y);
 printf(_name);
 gotoxy(x,++y);
 printf("wurde von Fabian Keil(fabiankeil@web.de) geschrieben,");
 gotoxy(x,++y);
 printf("der selbstverstndlich nichteinmal ansatzweise");
 gotoxy(x,++y);
 printf("die Haftung bernimmt.");
 gotoxy(x,++++y);
 printf(_name);
 printf(" steht unter der GPL.");
 getch();
 maldaskreuz(' ');
}
void parabelausgabe(double a2, double a1,double a0)
{
 double e;
 double f;
 int x=2;
 int y=2;
 e=-1*(a1/a2/2);
 f=a0- quadratvon(a1/(a2*2))*a2;
 gehwegtabelle();
 leerefeldoben();
 gotoxy(x,y++);
 if(a2)
 {
  printf("Die Funktion lautet f(x)= %lf x^2 + %lf x + %lf",a2,a1,a0);
  gotoxy(x,y);
  printf("Der Scheitelpunkt ist S=(%lf / %lf)",e,f);
 }
 else
 printf("Die Funktion lautet f(x)= %lf x + %lf",a1,a0);
}
int parabel (double &a2, double &a1, double &a0)
{
 //Hier kommen irgendwann vielleicht zwei Arrays hin.
 double x1,x2,x3;
 double y1,y2,y3;

 //Falls eine Division durch Null auftritt, werden die Positionen der Werte getauscht.
 double x_temporaer;
 double y_temporaer;
 int x;
 int y;
 x=26;
 y=6;
 gotoxy(x,y);
 printf("Geben sie X1 ein:                                     ");
 x1=scanfstinkt(44,y,0,0);
 gotoxy(x,++y);
 printf("Geben sie Y1 ein:                                     ");
 y1=scanfstinkt(44,y,0,0);
 y++;
 do
 {
  gotoxy(x,y);
  printf("Geben sie X2 ein:                                     ");
  x2=scanfstinkt(44,y,0,0);
  if(x2==x1)
  {
   gotoxy(x,y+1);
   printf("Dieser X-Wert ist schon vergeben.");
   getch();
   gotoxy(x,y);
   printf("                                  ");
  }
 }while(x2==x1);
 gotoxy(x,++y);
 printf("Geben sie Y2 ein:                                     ");
 y2=scanfstinkt(44,y,0,0);
 y++;
 do
 {
  gotoxy(x,y);
  printf("Geben sie X3 ein:                                     ");
  x3=scanfstinkt(44,y,0,0);
  if(x1==x2 || x1==x3 || x2==x3)
  {
   gotoxy(x,y+1);
   printf("Dieser X-Wert ist schon vergeben.");
   getch();
   gotoxy(x,y+1);
   printf("                                  ");
  }
 }while(x1==x2 || x1==x3 || x2==x3);
 gotoxy(x,++y);
 do
 {
  gotoxy(x,y);
  printf("Geben sie Y3 ein:                                     ");
  y3=scanfstinkt(44,y,0,0);
  if(y1==y2 && y2==y3)
	{
   gotoxy(x,y+1);
   printf("Drei gleiche Y-Werte sind bei Parabeln nicht mglich.");
   gotoxy(x,y+2);
   printf("Das Maximum betrgt 2, und es wurde schon erreicht.");
   getch();
   gotoxy(x,y+1);
   printf("                                                     ");
   gotoxy(x,y+2);
   printf("                                                    ");
  }
 }while(y1==y2 && y2==y3);
 gotoxy(x,++y);
 
 //Eine Division durch Null kann bei (x2-x3) nicht auftreten, da dafr die Werte von X2 und X3 gleich sein mssten,
 //Dies wre aber unzulssig, und wird daher schon vorher geblockt.

 //Bei ((quadratvon(x1)-quadratvon(x2)+((quadratvon(x2)-quadratvon(x3))*(x1-x2)*-1)/(x2-x3))) ist es aber mglich.
 //Daher werden vorher die Positionen der Werte vertauscht
 
 if(!(quadratvon(x1)-quadratvon(x2)+((quadratvon(x2)-quadratvon(x3))*(x1-x2)*-1)/(x2-x3)))
 {
  printf("Wertetausch");
  x_temporaer=x1;
  x1=x2;
  x2=x3;
  x3=x_temporaer;
  y_temporaer=y1;
  y1=y2;
  y2=y3;
  y3=y_temporaer;
 } 
 a2=(y1-y2-(x1-x2)*(y2-y3)/(x2-x3))/(quadratvon(x1)-quadratvon(x2)+((quadratvon(x2)-quadratvon(x3))*(x1-x2)*-1)/(x2-x3));
 a1=-a2*(quadratvon(x2)-quadratvon(x3))/(x2-x3)+(y2-y3)/(x2-x3);
 a0=y1-a2*quadratvon(x1)-a1*x1;
 return(0);
}

int parabelannahme(double &a2, double &a1, double &a0)
{
 int x=2;
 int y=2;
 leerefeldoben();
 do
 {
  gotoxy(x,y);
  printf("Geben sie a2 ein:                                   ");
  a2=scanfstinkt(x+20,y,0,0);
  if(!a2)
  {
   gotoxy(x,y+1);
   printf("Es gilt grundstzlich: a2!=0");
   getch();
   leerefeldoben();
  }
 }while(a2==0);
 gotoxy(x,y);
 printf("Geben sie a1 ein:                                    ");
 a1=scanfstinkt(x+20,y,0,0);
 gotoxy(x,y);
 printf("Geben sie a0 ein:                                    ");
 a0=scanfstinkt(x+20,y,0,0);
 return(0);
}

void parabelmain(double &a2, double &a1, double &a0)
{
 char wahl;
 int fehler;
 maldaskreuz('P');
 gehwegtabelle();
 gotoxy(26,6);
 printf("Waehlen sie zwischen;");
 gotoxy(26,7);
 printf("1)Parabel nach Eingabe von 3 Punkten berechnen");
 gotoxy(26,8);
 printf("2)Scheitelpunkt aus der Grundfunktion errechnen");
 do
 {
  wahl=toupper(getch());
 }
 while(wahl!='1' && wahl!='2');
 gehwegtabelle();
 if(wahl=='1')
 {
  fehler=parabel(a2,a1,a0);
 }
 else
 {
  fehler=parabelannahme(a2,a1,a0);
 }
 if(fehler)
 {
 }
 else
 {
  parabelausgabe(a2,a1,a0);
 }
 maldaskreuz(' ');
}

void gibaus(double zahl,int x,int y)
{
 /*
 Diese Funktion zerlegt bergebene Werte in ihre einzelnen Ziffern
 und gibt sie von rechts nach links aus. Die Kommastelle ist immer
 gleichweit von der ebenfalls bergebenen X-Koordinate entfernt.

 Beachten: Zahlen werden nicht gerundet!
 */
 int ziffernfeld[16];
 int anfangsnullen=0;
 int i;
 int frei=1;
 int negativ=0;
 float divisor=1000000000;
 gotoxy(x-18,y);
 printf("                   ");
 if(zahl<0)
 {
  zahl*=-1;
  negativ=1;
 }

 //Dies verhindert - keine Ahnung warum - merkwrdige Fehler bei den letzten Nachkommastellen
 zahl+=0.00000005;

 for(i=0;i<16;i++)
 {
  ziffernfeld[i]=zahl/divisor;

  if(i>=9)
  {
   frei=0;
  }
  if(!(ziffernfeld[i])&& frei)
  {
   anfangsnullen++;
  }
  else
  {
   frei=0;
  }
  zahl-=ziffernfeld[i]*divisor;
  divisor/=10;
 }

 //Zahl wird gerundet
 i=16;
 if(ziffernfeld[i]>=5)
 {
  while(i>=anfangsnullen)
  {
   if(++ziffernfeld[i]==10)
   {
    ziffernfeld[i]=0;
    --i;
   }
   else
   {
    break;
   }
  }
 }
 for(i=15;i>=anfangsnullen;i--)
 {
  gotoxy(x--,y);
  if(i==9)
  {
   printf(",");
   gotoxy(x--,y);
  }
  printf("%i",ziffernfeld[i]);
 }
 gotoxy(x-1,y);
 if(negativ)
 {
  printf("-");
 }
 else
 {
  printf(" ");
 }
}

double quadratvon(double wurzel)
{
 return(wurzel*wurzel);
}

void leerefeldoben(void)
{
 int y;
 for (y=2; y<5; y++)
 {
  gotoxy(2,y);
  printf("                                                                              ");
 }
}

void ausgleichsgerade(double &a1, double &a0)
{
 //Achtung: auschgleichsgerade() fngt keine Doppeleingaben ab.
 int index = 0;
 int zaehler = 0;
 int x = 26;
 int y = 6;
 double x_strich = 0;
 double y_strich = 0;
 int anzahl;
 double xkoordinaten[50];
 double ykoordinaten[50];
 double oben = 0;
 double unten= 0;

 maldaskreuz('A');
 gehwegtabelle();
 for(index=9;index!=0;index--)
 {
  xkoordinaten[index]=0;
  ykoordinaten[index]=0;
 }
 do
 {
  leerefeldoben();
  gotoxy(2,2);
  printf("Wieviele Wertepaare?");
  anzahl=scanfstinkt(22,2,1,1);
  if (anzahl<2)
  {
   gotoxy(2,3);
   printf("Eingaben kleiner 2 sind sinnlos, versuch's nochmal!");
   getch();
  }
  else if(anzahl>50)
  {
   gotoxy(2,3);
   printf("Die Eingabe ist momentan auf 50 Wertepaare begrenzt!");
   gotoxy(2,4);
   printf("Wenn das nicht reicht, sollte im Quelltext rumgefuscht werden.");
   getch();
  }
 }
 while(anzahl<2 || anzahl>50);
 do
 {
  gotoxy(x,y);
  zaehler++;
  printf("X%i =                                     ",zaehler);
  xkoordinaten[index]=scanfstinkt(x+5,y,0,0);
  gotoxy(x+15,y);
  printf("Y%i =        ",zaehler);
  ykoordinaten[index++]=scanfstinkt(x+20,y++,0,0);
  if(y==24)
  {
   gehwegtabelle();
   y=6;
  }
 }while(index<anzahl);
 
 /*
 //Mit diesen Werten sollte a1=0.545714 und a0=13.4 rauskommen!
 //Die obere Schleife sollte dafr natrlich auskommentiert werden.
 xkoordinaten[0]=10 ;
 xkoordinaten[1]=20 ;
 xkoordinaten[2]=30 ;
 xkoordinaten[3]=40 ;
 xkoordinaten[4]=50 ;
 xkoordinaten[5]=60 ;

 ykoordinaten[0]=23 ;
 ykoordinaten[1]=19 ;
 ykoordinaten[2]=28 ;
 ykoordinaten[3]=40 ;
 ykoordinaten[4]=37 ;
 ykoordinaten[5]=48 ;
 */
 for(index=0;index<anzahl;index++)
 {
  /*Zwischenergebnisse
  printf("\nIndex=%i	xkoordinate[%i]=%lf",index,index,xkoordinaten[index]);
  printf("\nIndex=%i	ykoordinate[%i]=%lf",index,index,ykoordinaten[index]);
  */
  x_strich=x_strich+xkoordinaten[index];
  y_strich=y_strich+ykoordinaten[index];
 }
 x_strich=x_strich/index;
 y_strich=y_strich/index;
 
 for(index=0;index<anzahl;index++)
 {
  oben=oben+(ykoordinaten[index]-y_strich)*(xkoordinaten[index]-x_strich);
  unten=unten+quadratvon(xkoordinaten[index]-x_strich);
 }
 a1=oben/unten;
 a0=y_strich - a1 * x_strich;
  
 for(y=18;y<24;y++)
 {
  gotoxy(x,y);
  printf("					               ");
 }
 y=18;
 gotoxy(x,y++);
 printf("x_strich = %lf",x_strich);
 gotoxy(x,y++);
 printf("y_strich = %lf",y_strich);
 gotoxy(x,y++);
 printf("Oben = %lf",oben);
 gotoxy(x,y++);
 printf("Unten = %lf",unten);
 gotoxy(x,y++);
 printf("a1 = %lf",a1);
 gotoxy(x,y);
 printf("a0 = %lf",a0);
 funktionsausgabe(a1,a0);
 maldaskreuz(' ');
}

void zeichnetabelle(void)
{
 int x,y,y1,x1;
 x=27;
 y=6;
 gotoxy(x,y);
 for(x1=x;x1<=50+x;++x1)
 {
  gotoxy(x1,y);
  printf("_");
  gotoxy(x1,y+2);
  printf("-");
  gotoxy(x1,y+17);
  printf("_");
 }
 for(y1=y+1;y1<=y+17;++y1)
 {
  gotoxy(x-1,y1);
	printf("|");
  gotoxy(x+25,y1);
  printf("|");
  gotoxy(x+51,y1);
  printf("|");
 }
 gotoxy(27,7);
 printf("x");
 gotoxy(53,7);
 printf("f(x)");
}
void fuelletabelle(double xwert, double a2, double steigungm, double verschiebungn,int x, int y)
{
 double ywert;
 //Das geht zwar bei linearen Funktionen auf die Performance, ist aber nicht so schlimm
 ywert = a2 * quadratvon(xwert) + steigungm * xwert + verschiebungn;
 gibaus(xwert,x   ,y);
 gibaus(ywert,x+26,y);
}
double scanfstinkt(int originalx,int originaly,int kommasperre,int keinminus)
{
 int x=originalx+1;
 int y=originaly;
 int taste, i;
 int positiv=1;
 int komma=0;
 int zaehler1=-1;
 int zaehler2=-1;
 double ergebnis=0;
 double multiplikator=1;
 int vorkomma[10];
 int nachkomma[7];

 do
 {
  do
  {
   gotoxy(x,y);
   taste=getch();
  }
  while(!(taste==45 && keinminus==0) && !(taste==43 && keinminus==0) && taste!=13 && !(taste==44 && kommasperre==0) && !(taste==46 && kommasperre==0) && !(taste>47 && taste<58) && taste!=8);
  if(taste==8)
  {
   if (komma==1)
   {
    if(zaehler2==-1)
    {
     komma=0;
     kommasperre=0;
    }
    else
    {
     --zaehler2;
    }
    if(x>originalx+1)
    {
     --x;
     gotoxy(x,y);
     printf("  ");
     gotoxy(x,y);
    }
   }
   else
   {
    if(x>originalx+1)
    {
     --x;
    }
    if(zaehler1>-1)
    {
     --zaehler1;
    }
    gotoxy(x,y);
    printf(" ");
   }
  }
  else
  {
   if(taste==45 || taste==44 || taste==46 || taste==13 || taste==43)
   {
    if(taste==46 || taste==44)
    {
     komma=1;
     kommasperre=1;
     printf(".");
     ++x;
    }
    if(taste==45)
    {
     gotoxy(originalx,y);
     positiv=0;
     printf("-");
    }
    if(taste==43)
    {
     gotoxy(originalx,y);
     positiv=1;
     printf("+");
    }
   }
   else
   {
   if(komma==1 && zaehler2<5)
    {
     ++zaehler2;
     nachkomma[zaehler2]=taste-48;
     ++x;
     printf("%c",taste);
    }
    else if(zaehler1<8 && zaehler2<5)
    {
     ++zaehler1;
     vorkomma[zaehler1]=taste-48;
     ++x;
     putch(taste);
    }    
   }
  }
 }
 while(taste!=13);
 
 if(zaehler1>-1)
 {
  for(i=zaehler1;i>=0;i--)
  {
   ergebnis=ergebnis + vorkomma[i] * multiplikator;
   multiplikator=multiplikator*10;
  }
 } 
 multiplikator=0.1;
 
 if(zaehler2>-1)
 { 
  for(i=0;i<=zaehler2;i++)
  {
   ergebnis=ergebnis + nachkomma[i] * multiplikator;
   multiplikator=multiplikator/10;
  }
 }
 if(!positiv)
 {
  ergebnis=-ergebnis;
 }
 //Die zweite Bedingung verhindert, dass bei Eingabe von 0 noch eine 0 angehngt wird.
 if(!ergebnis && x==originalx+1)
 {
  printf("0");
 }
 return ergebnis;
}

void wokreuztsie(double steigungm1, double verschiebungn1)
{
 int x,y,wahl;
 double p1x,p1y,p2x,p2y,spx,spy,steigungm2,verschiebungn2;
 gehwegtabelle();
 maldaskreuz('S');
 gotoxy(26,6);
 printf("Beachten: Parabeln sind noch nicht implementiert.");
 getch();
 gotoxy(26,6);
 printf("Waehlen sie zwischen:                                 ");
 gotoxy(26,7);
 printf("1) Die zweite Funktion erst aus zwei Punkten berechnen");
 gotoxy(26,8);
 printf("2) Die zweite Funktion direkt eingeben");
 do
 {
  wahl=getch();
 }
 while(wahl!='1' && wahl!='2');
 gehwegtabelle();
 if (wahl=='1')
 {
  p1x=inteingabe(1,1,2);
  p1y=inteingabe(2,1,2);
  do
  {
   p2x=inteingabe(1,2,2);
  }
  while(checkwerte(p1x,p2x,2));
  p2y=inteingabe(2,2,2);
  berechnung(p1x,p1y,p2x,p2y,steigungm2,verschiebungn2);

 }
 else
 {
  gotoxy(26,6);
  printf("Geben sie die Steigung ein         ");
  steigungm2=scanfstinkt(53,6,0,0);
  gotoxy(26,6);
  printf("Geben sie die Verschiebung ein     ");
  verschiebungn2=scanfstinkt(57,6,0,0);
 }
 gehwegtabelle();
 gotoxy(26,6);
 printf("Die zweite Funktionsgleichung lautet:");
 gotoxy(26,7);
 if (verschiebungn2>=0)
 {
  printf("g(x) = %lf x + %lf",steigungm2,verschiebungn2);
 }
 else
 {
  verschiebungn2 = verschiebungn2 * -1;
  printf("g(x) = %lf x - %lf",steigungm2,verschiebungn2);
  verschiebungn2 = verschiebungn2 * -1;
 }
 gotoxy(26,9); 
 if(steigungm1==steigungm2 && verschiebungn1!=verschiebungn2)
 {
  printf("Die beiden Funktionen schneiden sich nie.");
 }
 else if(steigungm1==steigungm2 && verschiebungn1==verschiebungn2)
 {
  printf("Die beiden Funktionen sind identisch.");
 }
 else
 {
  spx=-(verschiebungn1-verschiebungn2)/(steigungm1-steigungm2);
  spy=steigungm1 * spx + verschiebungn1; 
  printf("Die beiden Funktionen schneiden sich im Punkt");
  gotoxy(26,10);
  printf("S=(%lf/%lf)",spx,spy);
 }
 
}

int checkwerte(double p1x, double p2x, int a)
{
 int gleich;
 if(a==1)
 {
  gotoxy(2,3);
 }
 else
 {
  gotoxy(26,8);
 }
 if (p1x==p2x)
 {
  gleich=1;
  printf("Den Punkt mit dieser X-Koordinate gibt es schon");
  return gleich;
 }
 gleich=0;
 printf("                                                ");
 return gleich;
}
void schreibezeile(double xwert, double a2, double steigungm, double verschiebungn,int x, int y)
{
 double ywert;
 ywert = a2 * quadratvon(xwert) + steigungm * xwert + verschiebungn;
 gotoxy(x,y);
 printf("f(%.2lf)=%.2lf",xwert,ywert);

}
void gehwegtabelle(void)
{
 int y;
 for(y=6; y<=23; y=y+1)
 {
  gotoxy(26,y);
  printf("                                                      ");
 }
}

void danke(void)
{
 int x,y;
 y=15;
 x=27;
 maldaskreuz('E');
 gehwegtabelle();
 gotoxy(x,y);
 printf("Sie haben ein einfaches Programm glcklich gemacht!");
}

void maldaskreuz(char wo)
{
 int y;
 for (y=7; y<=15; y=y+1)
 {
  gotoxy(22,y);
  printf(" ");
 }
 switch(wo)
 {
 case 'K':
  y=7;
  break;
 case 'G':
  y=8;
  break;
 case 'F':
  y=9;
  break;
 case 'T':
  y=11;
  break;
 case 'S':
  y=12;
  break;
 case 'A':
  y=13;
  break;
 case 'P':
  y=14;
  break;
 case 'I':
  y=15;
  break;
 case 'E':
  y=16;
  break;
 case ' ':
  return;
 }
 gotoxy(22,y);
 printf("X");
}

void punktausgabe(double steigungm, double verschiebungn, double p1x, double p1y, double p2x, double p2y)
{
 gotoxy(2,2);
 printf ("Die Steigung betraegt %lf                                  ",steigungm);
 gotoxy(2,3);
 printf("Die Verschiebung an der Y-Achse betraegt %lf                ",verschiebungn);
 gotoxy(58,2);
 printf("P1=(%.2lf/%.2lf)", p1x, p1y);
 gotoxy(58,3);
 printf("P2=(%.2lf/%.2lf)", p2x, p2y);
 gotoxy(2,4);
 if (verschiebungn>=0)
 {
  printf("Die Funktionsgleichung lautet f(x) = %lf x + %lf",steigungm,verschiebungn);
 }
 else if (verschiebungn==0)
 {
  printf("Die Funktionsgleichung lautet f(x) = %lf x",steigungm);
 }
 else
 {
  verschiebungn = verschiebungn* -1;
  printf("Die Funktionsgleichung lautet f(x) = %lf x - %lf",steigungm,verschiebungn);
 }
}

void funktionsausgabe(double steigungm, double verschiebungn)
{
 gotoxy(2,2);
 printf ("Die Steigung betraegt %lf                                  ",steigungm);
 gotoxy(2,3);
 printf("Die Verschiebung an der Y-Achse betraegt %lf                ",verschiebungn);
 gotoxy(2,4);
 if (verschiebungn>=0)
 {
  printf("Die Funktionsgleichung lautet f(x) = %lf x + %lf",steigungm,verschiebungn);
 }
 else
 {
  verschiebungn = verschiebungn* -1;
  printf("Die Funktionsgleichung lautet f(x) = %lf x - %lf",steigungm,verschiebungn);
 }
}

void design(void)
{
 int y, y2;
 printf(" ______________________________________________________________________________");
 for (y=2; y<24; y=y+1)
 {
  gotoxy(1,y);
  printf("|");
  gotoxy(80,y);
  printf("|");
 }
 for (y=5; y<25; y=y+19)
 {
  gotoxy(1,y);        
  printf("|______________________________________________________________________________|");
 }

 for (y2=6; y2<25; y2=y2+1)
 {
  gotoxy(24,y2);
  printf("|");
 }
 gotoxy(2,21);
 printf("______________________");
 gotoxy(2,6);
 printf("Waehlen Sie zwischen:");
 gotoxy(2,7);
 printf("K)oordinateneingabe[ ]");
 gotoxy(2,8);
 printf("G)robe Tabelle     [ ]");
 gotoxy(2,9);
 printf("F)eine Tabelle     [ ]");
 gotoxy(2,10);
 printf(" Einzeleingabe");
 gotoxy(2,11);
 printf("T)abelle(scrollbar)[ ]");
 gotoxy(2,12);
 printf("S)chnittpunkte     [ ]");
 gotoxy(2,13);
 printf("A)usgleichsgerade  [ ]");
 gotoxy(2,14);
 printf("P)arabel           [ ]");
 gotoxy(2,15);
 printf("I)nformation       [ ]");
 gotoxy(2,16);
 printf("E)nde              [ ]");
 gotoxy(5,23);
 printf(_name);
}

char tastenannahme(void)
{
 char taste;
 gotoxy(24,24);
 do
 {
  taste=getch();
  taste=toupper(taste);
 }
 while (taste!='Z' && taste!='I' && taste != 'P' && taste !='A' && taste!='E' && taste!='K' && taste!='G' && taste!='F' && taste!='R' && taste!='S' && taste!='T');
 return taste;
}

double inteingabe(int a,int b, int c)
{
 double wert;
 maldaskreuz('K');
 if(c==1)
 {
 gehwegtabelle();
 gotoxy(2,2);
 printf("Bitte geben Sie die                                                         ");
 gotoxy(22,2);
 if (a==1 && b==1)
 {
  gotoxy(2,3);
  printf("                                                                            ");
  gotoxy(2,4);
  printf("                                                                            ");
  gotoxy(22,2);
  printf("X");
 }
 if(a==1 && b==2)
 {
  printf("X");
 }
 if(a==2)
 {
  printf("Y");
 }
 printf("-Koordinate von Punkt ");
 if (b==1)
  printf("1");
 else
  printf("2");
 printf(" an                          ");
 wert=scanfstinkt(50,2,0,0);
 maldaskreuz(' ');
 return wert;
 }
 gotoxy(26,6);
 printf("Bitte geben Sie die      ");
 gotoxy(46,6);
 if (a==1 && b==1)
 {
  printf("X");
 }
 if(a==1 && b==2)
 {
  printf("X");
 }
 if(a==2)
 {
  printf("Y");
 }
 printf("-Koordinate von Punkt ");
 if (b==1)
  printf("1");
 else
  printf("2");
 printf(" an  ");
 wert=scanfstinkt(26,7,0,0);
 gotoxy(26,7);
 printf("                            ");
 maldaskreuz(' ');
 return wert;
}

void berechnung(double p1x,double p1y, double p2x, double p2y, double &steigungm, double &verschiebungn)
{
 steigungm=(p2y-p1y)/(p2x-p1x);
 verschiebungn = p1y - steigungm * p1x;
}

void tabellevonbis(double a2, double steigungm, double verschiebungn)
{
 char taste;
 int nichtteilbar,durchgang,xanfang,xanzahl,x,y,zaehler;
 double schrittgroesse;
 double xwert;
 gehwegtabelle();
 maldaskreuz('G');
 x=26;
 y=6;
 gotoxy(x,y);
 printf("Wieviel Werte wollen sie sehen?");
 xanzahl=scanfstinkt(57,y,1,1);
 gotoxy(x,y);
 printf("                                          ");
 gotoxy(x,y);
 printf("Welcher Startwert?");
 xanfang=scanfstinkt(45,y,0,0);
 gotoxy(x,y);
 printf("                                          ");
 xwert=xanfang;
 gotoxy(x,y);
 printf("Welche Schrittgrsse?");
 schrittgroesse=scanfstinkt(48,y,0,0);
 gotoxy(x,y);
 printf("                                          ");
 durchgang=1;
 nichtteilbar=1;
 do
 {
  if(durchgang!=1)
  {
   nichtteilbar=(durchgang-1)%36;
  }
  
  if(nichtteilbar == 0)
  {
   gotoxy(2,18);
   printf("W drcken fuer");
   gotoxy(2,19);
   printf("die nchsten Werte");
   gotoxy(2,20);
   printf("A fuer Abbrechen");
   do
   {
    taste=getch();
    taste=toupper(taste);
   }
   while(taste!='A' && taste!='W');
   if(taste=='A')
   {
    break;
   }
   gehwegtabelle();
  }
  gotoxy(x,y);
  y = y + 1;
  if(y==24 && x==50)
  {
   x=26;
   y=6;
  }
  if (y==24)
  {
   x=50;
   y=6;
  }
  schreibezeile(xwert, a2, steigungm, verschiebungn,x,y);
  xwert= xwert + schrittgroesse;
  durchgang=durchgang+1;
 }
 while(durchgang<=xanzahl);
 gotoxy(2,18);
 printf("                   ");
 gotoxy(2,19);
 printf("                   ");
 gotoxy(2,20);
 printf("                   ");
 maldaskreuz(' ');
}

void scrolltabelle(double a2,double steigungm,double verschiebungn)
{
 double xwert,xwert1,start,abstandx,scrollum;
 int x,x1,y,y1;
 char taste;
 maldaskreuz('T');
 x=50;
 y=6;
 gotoxy(x,y);
 xwert=-7;
 abstandx=1;
 scrollum=1;
 gotoxy(x,y);
 printf("  ");
 gehwegtabelle();
 zeichnetabelle();
 do
 {
  y1=y+2;
  xwert1=xwert;
  do
  {
   fuelletabelle(xwert1,a2,steigungm,verschiebungn,x+1,++y1);
   xwert1=xwert1+abstandx;
  }
  while(y1<=y+15);
  do
  {
   taste=getch();
   taste=toupper(taste);
  }
  while(taste!='8' && taste!='2' && taste!='5' && taste!='A');
  if(taste=='A')
  {
   gehwegtabelle();
   gotoxy(26,6);
   printf("Geben sie den Startwert ein");
   xwert=scanfstinkt(26,7,0,0);
   gotoxy(26,7);
   printf("                                       ");
   gotoxy(26,6);
   printf("Geben sie den Abstand der X-Werte ein.");
   abstandx=scanfstinkt(26,7,0,0);
   gotoxy(26,7);
   printf("                                       ");
   gotoxy(26,6);
   printf("Wieviel soll pro Tastendruck gescrollt werden?");
   scrollum=scanfstinkt(26,7,0,0);
   gehwegtabelle();
   zeichnetabelle();
  }
  if (taste=='8')
  {
   xwert=xwert-scrollum;
  }
  if (taste=='2')
  {
   xwert=xwert+scrollum;
  }
 }
 while(taste!='5');
 maldaskreuz(' ');
}

void tabellefein(double a2, double steigungm,double verschiebungn)
{
 int x,y,anzahlx,zaehler;
 double xwert;
 x=26;
 y=6;
 maldaskreuz('F');
 gehwegtabelle();
 gotoxy(x,y);
 printf("Wieviel X-Werte wollen Sie eingeben?");
 anzahlx=scanfstinkt(63,6,1,1);
 gotoxy(x,y);
 printf("                                                      ");
 y=7;
 x=26;
 gotoxy(26,7);
 printf("f(x) = y");
 for (zaehler=1;zaehler<=anzahlx;zaehler=zaehler+1)
 {
  gotoxy(26,6);
  printf("Bitte geben Sie den %.0i. Xwert an         ",zaehler);
  xwert=scanfstinkt(58,6,0,0);
  y = y + 1;
  if (y==24 && x==50)
  {
   x=26;
   y=7;
   gehwegtabelle();
  }

  if (y==24)
  {
   x=50;
   y=7;
  }
  gotoxy(x,y);
  schreibezeile(xwert,a2,steigungm,verschiebungn,x,y);
 }
 gotoxy(26,6);
 printf("                                                  ");
 maldaskreuz(' ');
}

void main(void)
{
 double a2=3;
 double p1x=0, p1y=0, p2x=1, p2y=1;
 double steigungm=2, verschiebungn=1;
 char taste;
 clrscr();
 design();
 //Beispielsausgabe
 parabelausgabe(a2,steigungm,verschiebungn);
 do
 {
  taste=tastenannahme();
  switch (taste)
  {
   case 'K':
   a2=0;
   p1x=inteingabe(1,1,1);
   p1y=inteingabe(2,1,1);
   do
   {
    p2x=inteingabe(1,2,1);
   }
   while(checkwerte(p1x,p2x,1));
   p2y=inteingabe(2,2,1);
   berechnung(p1x,p1y,p2x,p2y,steigungm,verschiebungn);
   punktausgabe(steigungm, verschiebungn, p1x, p1y, p2x, p2y);
   break;

   case 'T':
   scrolltabelle(a2,steigungm,verschiebungn);
   break;

   case 'G':
   tabellevonbis(a2,steigungm, verschiebungn);
   break;

   case 'F':
   tabellefein(a2,steigungm,verschiebungn);
   break;

   case 'S':
   a2=0;
   wokreuztsie(steigungm,verschiebungn);
   break;

   case 'A':
   a2=0;
   ausgleichsgerade(steigungm, verschiebungn);
   break;

   case 'P':
   parabelmain(a2,steigungm,verschiebungn);
   break;

   case 'I':
   information();
   break;

   case 'R':
   //Sollte doch einmal das Design im A.. sein, hilft ein beherzter Druck auf die Redesign-Taste.
   clrscr();
   design();
   parabelausgabe(a2,steigungm,verschiebungn);
   gehwegtabelle();
  }
 }
 while (taste !='E');
 maldaskreuz('E');
 danke();
 getch();
}